/*     
  Canvas Query 0.9
  http://canvasquery.org
  (c) 2012-2013 http://rezoner.net
  Canvas Query may be freely distributed under the MIT license.
*/

(function(window, undefined) {

  var MOBILE = /Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent);


  window.requestAnimationFrame = (function() {
    return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame ||
    function(callback) {
      window.setTimeout(callback, 1000 / 60);
    };
  })();


  var $ = function(selector) {
      if(arguments.length === 0) {
        var canvas = $.createCanvas(window.innerWidth, window.innerHeight);
        window.addEventListener("resize", function() {
          // canvas.width = window.innerWidth;
          // canvas.height = window.innerHeight;
        });
      } else if(typeof selector === "string") {
        var canvas = document.querySelector(selector);
      } else if(typeof selector === "number") {
        var canvas = $.createCanvas(arguments[0], arguments[1]);
      } else if(selector instanceof Image || selector instanceof HTMLImageElement) {
        var canvas = $.createCanvas(selector);
      } else if(selector instanceof $.Wrapper) {
        return selector;
      } else {
        var canvas = selector;
      }

      return new $.Wrapper(canvas);
    }

  $.extend = function() {
    for(var i = 1; i < arguments.length; i++) {
      for(var j in arguments[i]) {
        arguments[0][j] = arguments[i][j];
      }
    }

    return arguments[0];
  }

  $.augment = function() {
    for(var i = 1; i < arguments.length; i++) {
      _.extend(arguments[0], arguments[i]);
      arguments[i](arguments[0]);
    }
  }

  $.extend($, {

  $.Wrapper.prototype = {

    trim: function(color, changes) {
      var transparent;

      if(color) {
        color = $.color(color).toArray();
        transparent = !color[3];
      } else transparent = true;

      var sourceData = this.context.getImageData(0, 0, this.canvas.width, this.canvas.height);
      var sourcePixels = sourceData.data;

      var bound = [this.canvas.width, this.canvas.height, 0, 0];

      for(var i = 0, len = sourcePixels.length; i < len; i += 4) {
        if(transparent) {
          if(!sourcePixels[i + 3]) continue;
        } else if(sourcePixels[i + 0] === color[0] && sourcePixels[i + 1] === color[1] && sourcePixels[i + 2] === color[2]) continue;
        var x = (i / 4 | 0) % this.canvas.width | 0;
        var y = (i / 4 | 0) / this.canvas.width | 0;

        if(x < bound[0]) bound[0] = x;
        if(x > bound[2]) bound[2] = x;

        if(y < bound[1]) bound[1] = y;
        if(y > bound[3]) bound[3] = y;
      }

      if(bound[2] === 0 || bound[3] === 0) {

      } else {
        if(changes) {
          changes.left = bound[0];
          changes.top = bound[1];
          changes.width = bound[2] - bound[0];
          changes.height = bound[3] - bound[1];
        }
        
        this.crop(bound[0], bound[1], bound[2] - bound[0] + 1, bound[3] - bound[1] + 1);
      }

      return this;
    },

  };

})(window);